void LoadMed(const TStr DataFNm, TVec<TFltIntPrV>& RawChainV, TStrHash<TInt>& ChainIDH, TIntStrH& IIDNameH) {
  TStr DataPath = DataFNm.GetFPath();
  TStr ICFNm = DataPath + "cname.txt";
  printf("IC File Name:%s\n", ICFNm.CStr());
  TSsParser SsC(ICFNm, ssfTabSep);
  while (SsC.Next()) {
    int CID = SsC.GetInt(0);
    TStr CName = SsC.GetFld(1);
    IIDNameH.AddDat(CID, CName);
  }
  printf("names for %d items loaded\n", IIDNameH.Len());
  TSsParser Ss(DataFNm, ssfTabSep);
  int LCnt = 0, ItemCnt = 0;
  Ss.Next(); //pid     timeoffset      year    cid     str     negated nid     tid
  while (Ss.Next()) {
    if (! Ss.IsInt(3)) { continue; }
    int IID = Ss.GetInt(3);
    if (! IIDNameH.IsKey(IID)) { continue; }
    if (Ss.GetInt(5) == 1) { continue; }
    TFlt ITime = Ss.GetFlt(1);
    TStr CName = Ss.GetFld(0);
    ChainIDH.AddDat(CName);
    int CID = ChainIDH.GetKeyId(CName);
    if (RawChainV.Len() == CID) { RawChainV.Add(); }
    IAssert(RawChainV.Len() > CID);
    RawChainV[CID].Add(TFltIntPr(ITime, IID));
      
    //printf("Item ID: %d, Chain ID:%d, Time:%d, User:%s\n", IID, CID, (uint) ITime, CName.CStr());
    ItemCnt++;
    //if (ItemCnt > 100) { break; }
  }
  for (int c = 0; c < RawChainV.Len(); c++) {
    RawChainV[c].Sort();
  }

  printf("%d chains loaded. %d items\n", RawChainV.Len(), ItemCnt);
}

void LoadAmazon(const TStr DataFNm, TVec<TFltIntPrV>& RawChainV, TStrHash<TInt>& ChainIDH, TStrHash<TInt>& ItemIDH) {
  printf("loading begins\n");
//A3LB5E8CKKKBTY B000HI7E1I 5.0 1304208000 26 thi
  TSsParser Ss(DataFNm, ssfWhiteSep);
  int LCnt = 0, ItemCnt = 0;
  while (Ss.Next()) {
    if (Ss.GetFlds() < 4) { continue; }
    if (! Ss.IsFlt(3)) { continue; }
    TStr CName = Ss.GetFld(0);
    TStr IStr = Ss.GetFld(1);
    double ITime = Ss.GetFlt(3);
    ChainIDH.AddKey(CName);
    int CID = ChainIDH.GetKeyId(CName);
    ItemIDH.AddKey(IStr);
    int IID = ItemIDH.GetKeyId(IStr);
    if (RawChainV.Len() == CID) { RawChainV.Add(); }
    IAssert(RawChainV.Len() > CID);
    RawChainV[CID].Add(TFltIntPr(ITime, IID));
    //printf("Item ID: %d, Chain ID:%d, Time:%d, User:%s, Item:%s\n", IID, CID, (uint) ITime, CName.CStr(), IStr.CStr());
    ItemCnt++;
    //if (ItemCnt > 10) { break; }
  }
  for (int c = 0; c < RawChainV.Len(); c++) {
    RawChainV[c].Sort();
  }
  printf("%d chains loaded. %d items\n", RawChainV.Len(), ItemCnt);
}

void LoadAmazonTitle(const TStr DataFNm, TIntStrH& IIDNameH, const TStrHash<TInt>& IIDStrH) {
  TSsParser Ss(DataFNm, ssfWhiteSep);
  int LCnt = 0, ItemCnt = 0;
  while (Ss.Next()) {
    if (Ss.GetFlds() < 2) { continue; }
    TStr IStr = Ss.GetFld(0);
    if (! IIDStrH.IsKey(IStr)) { continue; }
    int IID = IIDStrH.GetKeyId(IStr);
    TStr IName = Ss.GetFld(1);
    for (int s = 2; s < Ss.GetFlds(); s++) {
      IName += (" " + TStr(Ss.GetFld(s)));
    }
    IName += "-" + IStr;
    //printf("IID:%d, Str:%s, Name:%s\n", IID, IStr.CStr(), IName.CStr());
    IIDNameH.AddDat(IID, IName);
  }

}

void LoadBeer(const TStr DataFNm, TVec<TFltIntPrV>& RawChainV, TStrHash<TInt>& ChainIDH, TIntStrH& IIDNameH) {
  TSsParser Ss(DataFNm, ssfWhiteSep);
  int LCnt = 0, ItemCnt = 0;
  while (Ss.Next()) {
    //if (LCnt++ > 50) { break; }
    //printf("%s\n", Ss.DumpStr());
    TStr LineStr = Ss.GetFld(0);
    if (LineStr == "beer/name:") {
      TStr IName = Ss.GetFld(1);
      for (int k = 2; k < Ss.GetFlds(); k++) {
        IName += " ";
        IName += Ss.GetFld(k);
      }
      Ss.Next();
      IAssert(TStr(Ss.GetFld(0)) == "beer/beerId:");
      if (! Ss.IsInt(1)) { continue; }
      int IID = Ss.GetInt(1);
      for(int i = 0; i < 9; i++) { Ss.Next(); }
      IAssert(TStr(Ss.GetFld(0)) == "review/time:");
      TFlt ITime = Ss.GetFlt(1);
      Ss.Next();
      //printf("%s", Ss.DumpStr());
      IAssert(TStr(Ss.GetFld(0)) == "review/profileName:");
      TStr CName = Ss.GetFld(1);
      ChainIDH.AddDat(CName);
      int CID = ChainIDH.GetKeyId(CName);
      if (RawChainV.Len() == CID) { RawChainV.Add(); }
      IAssert(RawChainV.Len() > CID);
      RawChainV[CID].Add(TFltIntPr(ITime, IID));
      IIDNameH.AddDat(IID, IName);
      //printf("Item ID: %d, Chain ID:%d, Time:%d, User:%s\n", IID, CID, (uint) ITime, CName.CStr());
      ItemCnt++;
    }
  }
  for (int c = 0; c < RawChainV.Len(); c++) {
    RawChainV[c].Sort();
  }
  printf("%d chains loaded. %d items\n", RawChainV.Len(), ItemCnt);
}

void ApplyMinItemsChains(const TVec<TFltIntPrV>& RawChainV, THash<TInt, TFltIntPrV>& CIDChainH, const int MinChains, const int MinItems, const bool UseOrder = true) {
  CIDChainH.Gen(RawChainV.Len());
  TIntH IIDCntH; // Item ID - Count Hashtable
  for (int c = 0; c < RawChainV.Len(); c++) {
    for (int i = 0; i < RawChainV[c].Len(); i++) {
      IIDCntH.AddDat(RawChainV[c][i].Val2)++;
    }
  }

  int CntMinChain = 0;
  for (int i = 0; i < IIDCntH.Len(); i++) {
    if (IIDCntH[i] >= MinChains) { CntMinChain++; }
  }
  printf("%d / %d items belong to at least %d chains\n", CntMinChain, IIDCntH.Len(), MinChains);

  int CntMinItem = 0;
  for (int c = 0; c < RawChainV.Len(); c++) {
    if (RawChainV[c].Len() >= MinItems) { CntMinItem++; }
  }
  printf("%d / %d chains have at least %d items\n", CntMinItem, RawChainV.Len(), MinItems);

  int TotalChainLength = 0;
  for (int c = 0; c < RawChainV.Len(); c++) {
    if (RawChainV[c].Len() >= MinItems) { 
      TFltIntPrV Chain;
      for (int i = 0; i < RawChainV[c].Len(); i++) {
        if (IIDCntH.GetDat(RawChainV[c][i].Val2) >= MinChains) { Chain.Add(RawChainV[c][i]); }
      }
      if (Chain.Len() < MinItems) { continue; }
      Chain.Sort(true);
      if (Chain.Last().Val1 == 0.0) { continue; }
      CIDChainH.AddDat(c, Chain);
      TotalChainLength += Chain.Len();
    }
  }
  printf("%d chains remain (average length: %.2f)\n", CIDChainH.Len(), (double) TotalChainLength / (double) CIDChainH.Len());

  for (int c = 0; c < CIDChainH.Len(); c++) {
    int CLen = CIDChainH[c].Len();
    double MaxTime = CIDChainH[c].Last().Val1;
    for (int i = 0; i < CIDChainH[c].Len(); i++) {
      if (c == 0 && i < 10) { printf("%d: %f\n", i, CIDChainH[c][i].Val1.Val); }
      if (UseOrder) {
        CIDChainH[c][i].Val1 = (double) i / (double) CLen;
      } 
    }
  }
}

